<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="html" doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN" />



<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
                                       MAIN
  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->
<xsl:template match="/System_Info">

	<html>
		<head>
			<title>Futuremark SystemInfo Explorer</title>
			<link type="text/css" rel="stylesheet" href="systeminfo_explorer_2.css"/>
		</head>
	<body>

	<!-- Header picture -->
	<table cellpadding="0" cellspacing="0" border="0" width="100%">
		<tr>
			<td><img src="images/header_1.gif" alt="" border="0" /></td>
			<td style="background: url(images/header_2.gif);" width="100%"><img src="images/header_2.gif" alt="" border="0" /></td>
			<td><img src="images/header_3.gif" alt="" border="0" /></td>
		</tr>
	</table>

	<!-- Categories -->

	<div class="categoryTitle">CPU Info</div>
	<div class="categoryContainer"><xsl:apply-templates select="/System_Info/CPU_Info" /></div>
	<div class="categoryTitle">DirectX Info</div>
	<div class="categoryContainer"><xsl:apply-templates select="/System_Info/DirectX_Info" /></div>
	<div class="categoryTitle">Memory Info</div>
	<div class="categoryContainer"><xsl:apply-templates select="/System_Info/Memory_Info" /></div>
	<div class="categoryTitle">Storage Devices</div>
	<div class="categoryContainer"><xsl:apply-templates select="/System_Info/Storage_Devices" /></div>
	<div class="categoryTitle">Operating system info</div>
	<div class="categoryContainer"><xsl:apply-templates select="/System_Info/Operating_System_Info" /></div>
	<div class="categoryTitle">Monitor info</div>
	<div class="categoryContainer"><xsl:apply-templates select="/System_Info/Monitor_Info" /></div>
	<div class="categoryTitle">Mainboard info</div>
	<div class="categoryContainer"><xsl:apply-templates select="/System_Info/Motherboard_Info" /></div>

	<table cellpadding="0" cellspacing="0" border="0" width="100%">
		<tr>
			<td><img src="images/footer_01.gif" alt="" border="0" /></td>
			<td style="background: url(images/footer_02.gif);" width="100%"><img src="images/footer_02.gif" alt="" width="283" height="65" border="0" /></td>
			<td><img src="images/footer_03.gif" alt="" width="310" height="65" border="0" /></td>
		</tr>
	</table>

	</body>
	</html>
</xsl:template>



<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
                            	CATEGORIES
  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->

<!-- CPU Info -->
<xsl:template match="CPU_Info">

	<!-- General info -->
	<div class="box"><span class="nodeName">Physical processors </span><xsl:value-of select="Physical_Processors"/></div>
	<div class="box"><span class="nodeName">Logical processors </span><xsl:value-of select="Logical_Processors"/></div>

	<!-- Details of each processor. -->
    <xsl:for-each select="Central_Processing_Units/Central_Processing_Unit">
    	<!--<td><xsl:value-of select="Manufacturer"/></td>-->

    	<!-- Display all childs. -->
		<div style="clear: both">
    	<table class="dataTable" cellspacing="0" cellpadding="0">
    	<tr><th colspan="2">CPU</th></tr>
		<xsl:for-each select="*[(name() != 'CPUIDs') and (name() != 'Ext_CPUIDs') and (name() != 'Caches')]">

			<!-- Name (replace "_" => " ") -->
			<tr>
			<td class="nodeName">
			<xsl:call-template name="replace-string">
		     	<xsl:with-param name="text" select="name()"/>
		        <xsl:with-param name="from" select="'_'"/>
		        <xsl:with-param name="to" select="' '"/>
		    </xsl:call-template>
			</td>
			<td class="nodeValue">
			<!-- Value -->
			<xsl:apply-templates select="node()" />
			</td>
			</tr>

		</xsl:for-each>


		<tr>
		<td class="nodeName">
		Caches
		</td>
		<td class="nodeValue">
		<xsl:for-each select="Caches/Cache">

	    	<table class="dataTable" cellspacing="0" cellpadding="0">
	    	<tr><th colspan="2">Cache</th></tr>
			<xsl:for-each select="*">
				<!-- Name (replace "_" => " ") -->
				<tr>
				<td class="nodeName">
				<xsl:call-template name="replace-string">
			     	<xsl:with-param name="text" select="name()"/>
			        <xsl:with-param name="from" select="'_'"/>
			        <xsl:with-param name="to" select="' '"/>
			    </xsl:call-template>
				</td>
				<td class="nodeValue">
				<!-- Value -->
				<xsl:apply-templates select="node()" />
				</td>
				</tr>
			</xsl:for-each>
			</table>




		</xsl:for-each>
		</td>
		</tr>

		</table>
		</div>

    </xsl:for-each>

</xsl:template>


<!-- DirectX info -->
<xsl:template match="DirectX_Info">

	<!-- General info -->
	<div class="box"><span class="nodeName">Version </span><xsl:value-of select="Version"/></div>
	<div class="box"><span class="nodeName">Long version </span><xsl:value-of select="Long_Version"/></div>

	<!-- Details of directx components. -->
    <xsl:for-each select="./*[(name() != 'Version') and (name() != 'Long_Version')]">

		<div style="clear: both">
    	<table class="dataTable" cellspacing="0" cellpadding="0">
    	<tr><th colspan="2">
			<xsl:call-template name="replace-string">
		     	<xsl:with-param name="text" select="name()"/>
		        <xsl:with-param name="from" select="'_'"/>
		        <xsl:with-param name="to" select="' '"/>
		    </xsl:call-template>
		</th></tr>

    	<!-- Display all childs -->
		<xsl:for-each select="./*">

				<tr>
				<td class="nodeName">
				<!-- Replace "_" => " " -->
				<xsl:call-template name="replace-string">
			     	<xsl:with-param name="text" select="name()"/>
			        <xsl:with-param name="from" select="'_'"/>
			        <xsl:with-param name="to" select="' '"/>
			    </xsl:call-template>
				</td>
				<td class="nodeValue">

      			<xsl:choose>

					<!-- Audio filters -->
	          		<xsl:when test="name() = 'Registered_DirectShow_Filters'">
						<xsl:for-each select="*">
							<xsl:value-of select="node()"/>,
						</xsl:for-each>
					</xsl:when>

					<!-- Devices -->
	          		<xsl:when test="name() = 'Display_Devices'">
						<!-- Display adatper list, if in direct draw row. -->
				       	<xsl:if test="name() = 'Display_Devices'">
							<!-- Adapter -->
							<xsl:for-each select="Display_Device">

						    	<!-- Display all childs. -->
						    	<table class="dataTable" cellspacing="0" cellpadding="0">
						    	<tr><th colspan="2">Display device</th></tr>
								<xsl:for-each select="*">

									<!-- Name (replace "_" => " ") -->
									<tr>
									<td class="nodeName">
									<xsl:call-template name="replace-string">
								     	<xsl:with-param name="text" select="name()"/>
								        <xsl:with-param name="from" select="'_'"/>
								        <xsl:with-param name="to" select="' '"/>
								    </xsl:call-template>
									</td>
									<td class="nodeValue">

									<!-- Texture format is list... -->
					      			<xsl:choose>
										<!-- Texture format is list... -->
						          		<xsl:when test="name() = 'Texture_Formats'">
											<xsl:for-each select="*">
												<xsl:value-of select="node()"/>,
											</xsl:for-each>
										</xsl:when>
										<!-- Bus -->
						          		<xsl:when test="name() = 'Bus'">
											<xsl:for-each select="*">
												<xsl:call-template name="replace-string">
											     	<xsl:with-param name="text" select="name()"/>
											        <xsl:with-param name="from" select="'_'"/>
											        <xsl:with-param name="to" select="' '"/>
											    </xsl:call-template>:
												<xsl:value-of select="node()"/><br />
											</xsl:for-each>
										</xsl:when>
										<!-- Just values -->
										<xsl:otherwise>
											<!-- Value -->
											<xsl:apply-templates select="node()" />
										</xsl:otherwise>
									</xsl:choose>

									</td>
									</tr>

								</xsl:for-each>
								</table>

							</xsl:for-each>
				   		</xsl:if>
					</xsl:when>
					<!-- Standard value -->
					<xsl:otherwise>
						<!-- Value -->
						<xsl:apply-templates select="node()" />
					</xsl:otherwise>
				</xsl:choose>

				</td>
				</tr>

     		<!--</xsl:if>-->

		</xsl:for-each>

		</table>
		</div>

    </xsl:for-each>

</xsl:template>



<!-- Memory Info -->
<xsl:template match="Memory_Info">

	<!-- General info -->
	<div class="box">
		<span class="nodeName">Total Physical Memory </span><xsl:apply-templates select="Total_Physical_Memory"/><br />
		<span class="nodeName">Free Physical Memory </span><xsl:apply-templates select="Free_Physical_Memory"/><br />
	</div>
	<div class="box">
		<span class="nodeName">Total Pagefile Memory </span><xsl:apply-templates select="Total_Pagefile_Memory"/><br />
		<span class="nodeName">Free Pagefile Memory </span><xsl:apply-templates select="Free_Pagefile_Memory"/><br />
	</div>

	<!-- Details of each memory array. -->
    <xsl:for-each select="Memory_Arrays/Memory_Array">

		<!-- Memory array title -->
		<div style="clear: both">
    	<table class="dataTable" cellspacing="0" cellpadding="0">
    	<tr><th colspan="2">Memory array</th></tr>

    	<!-- Display all childs. -->
		<xsl:for-each select="*">

			<!-- Name (replace "_" => " ") -->
			<tr>
			<td class="nodeName">
			<xsl:call-template name="replace-string">
		     	<xsl:with-param name="text" select="name()"/>
		        <xsl:with-param name="from" select="'_'"/>
		        <xsl:with-param name="to" select="' '"/>
		    </xsl:call-template>
			</td>
			<td class="nodeValue">

  			<xsl:choose>
				<!-- Show each memory slot -->
          		<xsl:when test="name() = 'Memory_Slots'">
					<xsl:for-each select="*">

						<div style="clear: both">
				    	<table class="dataTable" cellspacing="0" cellpadding="0">
				    	<tr><th colspan="2">Memory slot</th></tr>
						<!-- Memory slot specs -->
						<xsl:for-each select="*">

							<!-- Name (replace "_" => " ") -->
							<tr>
							<td class="nodeName">
							<xsl:call-template name="replace-string">
						     	<xsl:with-param name="text" select="name()"/>
						        <xsl:with-param name="from" select="'_'"/>
						        <xsl:with-param name="to" select="' '"/>
						    </xsl:call-template>
							</td>
							<td class="nodeValue">

							<!-- Value -->
							<xsl:apply-templates select="node()" />
							</td>
							</tr>

						</xsl:for-each>
						</table>
						</div>

					</xsl:for-each>
				</xsl:when>
				<xsl:otherwise>
					<!-- Plain value -->
					<xsl:apply-templates select="node()" />
				</xsl:otherwise>
			</xsl:choose>

			</td>
			</tr>

		</xsl:for-each>
		</table>
		</div>

    </xsl:for-each>

</xsl:template>


<!-- Template for printing PCI information -->
<!--<xsl:template match="Name[name(parent::node()) = 'PCI']">
	<xsl:value-of select="./Name" />
</xsl:template>
-->

<!-- Motherboard Info -->
<xsl:template match="Motherboard_Info">

	<!-- General info -->

	<table class="dataTable" cellspacing="0" cellpadding="0">

	<!-- Display simple text childs -->
    <xsl:for-each select="*[(name() != 'AGP') and (name() != 'Card_Slots') and (name() != 'PCI_Devices') and (name() != 'System_Devices') and (name() != 'USB_Devices') and (name() != 'FireWire_Devices')]">

		<tr>
		<td class="nodeName">
			<xsl:call-template name="replace-string">
		     	<xsl:with-param name="text" select="name()"/>
		        <xsl:with-param name="from" select="'_'"/>
		        <xsl:with-param name="to" select="' '"/>
		    </xsl:call-template>
		</td>
		<td class="nodeValue">
			<!-- value -->
			<xsl:apply-templates select="node()" />
		</td>
		</tr>
    </xsl:for-each>

	<!-- Display AGP table. -->
    <xsl:for-each select="AGP">

		<!-- Title to left column. -->
		<tr>
		<td class="nodeName">
			<xsl:call-template name="replace-string">
		     	<xsl:with-param name="text" select="name()"/>
		        <xsl:with-param name="from" select="'_'"/>
		        <xsl:with-param name="to" select="' '"/>
		    </xsl:call-template>
		</td>
		<td class="nodeValue">

	    	<!-- Display all AGP features. -->
	    	<table class="dataTable" cellspacing="0" cellpadding="0">
	    	<tr><th colspan="2">AGP information</th></tr>
			<xsl:for-each select="*">

				<!-- Name (replace "_" => " ") -->
				<tr>
				<td class="nodeName" style="padding: 0px; padding-bottom: 1px;">
				<xsl:call-template name="replace-string">
			     	<xsl:with-param name="text" select="name()"/>
			        <xsl:with-param name="from" select="'_'"/>
			        <xsl:with-param name="to" select="' '"/>
			    </xsl:call-template>
				</td>
				<td class="nodeValue" style="padding: 0px; padding-bottom: 1px;">
					<!-- Value -->
					<xsl:apply-templates select="node()" />
				</td>
				</tr>

			</xsl:for-each>
			</table>

		</td>
		</tr>
    </xsl:for-each>



	<!-- Display list childs -->
    <xsl:for-each select="*[(name() = 'Card_Slots') or (name() = 'PCI_Devices') or (name() = 'System_Devices') or (name() = 'USB_Devices') or (name() = 'FireWire_Devices')]">
		<tr>
		<td class="nodeName">
			<xsl:call-template name="replace-string">
		     	<xsl:with-param name="text" select="name()"/>
		        <xsl:with-param name="from" select="'_'"/>
		        <xsl:with-param name="to" select="' '"/>
		    </xsl:call-template>
		</td>
		<td class="nodeValue">

			<!-- Each component has its own table -->
		    <xsl:for-each select="*">

				<table class="dataTable" cellspacing="0" cellpadding="0">
				<tr>
					<th colspan="2">
					<!-- name -->
					<xsl:call-template name="replace-string">
				     	<xsl:with-param name="text" select="name()"/>
				        <xsl:with-param name="from" select="'_'"/>
				        <xsl:with-param name="to" select="' '"/>
				    </xsl:call-template>
					</th>
				</tr>


			    <xsl:for-each select="*">
					<tr>
					<td class="nodeName" style="padding: 0px; padding-bottom: 1px;">
						<!-- name -->
						<xsl:call-template name="replace-string">
					     	<xsl:with-param name="text" select="name()"/>
					        <xsl:with-param name="from" select="'_'"/>
					        <xsl:with-param name="to" select="' '"/>
					    </xsl:call-template>
					</td>
					<td class="nodeValue" style="padding: 0px; padding-bottom: 1px;">
						<!-- value -->
						<xsl:choose>
							<xsl:when test="name() = 'PCI'">
								<xsl:apply-templates select="Name" />
							</xsl:when>
							<xsl:otherwise>
								<xsl:apply-templates select="node()" />
							</xsl:otherwise>
						</xsl:choose>
					</td>
					</tr>
			    </xsl:for-each>
			    </table>



		    </xsl:for-each>



		</td>
		</tr>
    </xsl:for-each>


	</table>

</xsl:template>


<!-- Monitor info -->
<xsl:template match="Monitor_Info">

	<!-- Details of each monitor. -->
    <xsl:for-each select="*">

    	<!-- Display all childs. -->
    	<table class="dataTable" cellspacing="0" cellpadding="0">
    	<tr><th colspan="2">Monitor</th></tr>
		<xsl:for-each select="Monitor/*">

			<!-- Name (replace "_" => " ") -->
			<tr>
			<td class="nodeName">
			<xsl:call-template name="replace-string">
		     	<xsl:with-param name="text" select="name()"/>
		        <xsl:with-param name="from" select="'_'"/>
		        <xsl:with-param name="to" select="' '"/>
		    </xsl:call-template>
			</td>
			<td class="nodeValue">
			<!-- Value -->
			<xsl:apply-templates select="node()" />
			</td>
			</tr>

		</xsl:for-each>
		</table>

    </xsl:for-each>

</xsl:template>




<!-- OS Info -->
<xsl:template match="Operating_System_Info">

	<table class="dataTable" cellspacing="0" cellpadding="0">

	<!-- Display childs -->
    <xsl:for-each select="*[(name() != 'DEP') and (name() != 'Windows_Experience_Index') and (name() != 'Applications') and (name() != 'Processes') and (name() != 'Logical_Drives')]">

		<tr>
		<td class="nodeName">
			<xsl:call-template name="replace-string">
		     	<xsl:with-param name="text" select="name()"/>
		        <xsl:with-param name="from" select="'_'"/>
		        <xsl:with-param name="to" select="' '"/>
		    </xsl:call-template>
		</td>
		<td class="nodeValue">

			<xsl:apply-templates select="node()" />

		</td>
		</tr>
    </xsl:for-each>

	<!-- Experience index -->
    <xsl:for-each select="Windows_Experience_Index">

		<!-- Title to left column. -->
		<tr>
		<td class="nodeName">
			<xsl:call-template name="replace-string">
		     	<xsl:with-param name="text" select="name()"/>
		        <xsl:with-param name="from" select="'_'"/>
		        <xsl:with-param name="to" select="' '"/>
		    </xsl:call-template>
		</td>
		<td class="nodeValue">

	    	<!-- Display all WEI properties. -->
	    	<table class="dataTable" cellspacing="0" cellpadding="0">
	    	<tr><th colspan="2">Information</th></tr>
			<xsl:for-each select="*[(name() != 'Sub_Indices')]">

				<!-- Name (replace "_" => " ") -->
				<tr>
				<td class="nodeName" style="padding: 0px; padding-bottom: 1px;">
				<xsl:call-template name="replace-string">
			     	<xsl:with-param name="text" select="name()"/>
			        <xsl:with-param name="from" select="'_'"/>
			        <xsl:with-param name="to" select="' '"/>
			    </xsl:call-template>
				</td>
				<td class="nodeValue" style="padding: 0px; padding-bottom: 1px;">
					<!-- Value -->
					<xsl:apply-templates select="node()" />
				</td>
				</tr>

			</xsl:for-each>

			<!-- Sub indices -->
			<xsl:for-each select="Sub_Indices">

				<!-- Name (replace "_" => " ") -->
				<tr>
				<td class="nodeName" style="padding: 0px; padding-bottom: 1px;">
				<xsl:call-template name="replace-string">
			     	<xsl:with-param name="text" select="name()"/>
			        <xsl:with-param name="from" select="'_'"/>
			        <xsl:with-param name="to" select="' '"/>
			    </xsl:call-template>
				</td>
				<td class="nodeValue" style="padding: 0px; padding-bottom: 1px;">

					<table class="indices">
					<xsl:for-each select="*">
						<tr>
						<td><xsl:apply-templates select="Name" /></td>
						<td><xsl:apply-templates select="Description" /></td>
						<td><xsl:apply-templates select="Title" /></td>
						<td><xsl:apply-templates select="Score" /></td>
						</tr>
					</xsl:for-each>
					</table>

				</td>
				</tr>

			</xsl:for-each>

			</table>

		</td>
		</tr>
    </xsl:for-each>


	<!-- Applications -->
	<tr>
	<td class="nodeName">
	Applications
	</td>
	<td class="nodeValue">
    <xsl:for-each select="Applications/Application">
		<xsl:apply-templates select="node()" /><br />
    </xsl:for-each>
	</td>
	</tr>

	<!-- Processes -->
	<tr>
	<td class="nodeName">
	Processes
	</td>
	<td class="nodeValue">
	<table class="dataTable" cellspacing="0" cellpadding="0">
	<th>Name</th><th>PID</th><th>Memory usage</th>
    <xsl:for-each select="Processes/Process">
		<tr>
		<td class="nodeValueFree"><xsl:apply-templates select="Name" /></td>
		<td class="nodeValueFree"><xsl:apply-templates select="PID" /></td>
		<td class="nodeValueFree"><xsl:apply-templates select="Memory_Usage" /></td>
		</tr>
    </xsl:for-each>
	</table>
	</td>
	</tr>

	<!-- Drives -->
	<tr>
	<td class="nodeName">
	Logical Drives
	</td>
	<td class="nodeValueFree">
	<table class="dataTable" cellspacing="0" cellpadding="0">
	<th>Letter</th><th>Label</th><th>Type</th><th>Capacity</th><th>Available</th>
    <xsl:for-each select="Logical_Drives/Logical_Drive">
		<tr>
	    <xsl:for-each select="*">
			<td class="nodeValueFree"><xsl:apply-templates select="node()" /></td>
	    </xsl:for-each>
		</tr>
    </xsl:for-each>
	</table>
	</td>
	</tr>

	</table>

</xsl:template>




<!-- Storage devices Info -->
<xsl:template match="Storage_Devices">

	<!-- Display devices -->
    <xsl:for-each select="*">

		<!-- Device properties -->
		<table class="dataTable" cellspacing="0" cellpadding="0">
		<tr><th colspan="2"><xsl:value-of select="./Name" /></th></tr>
	    <xsl:for-each select="*">
			<tr>
			<td class="nodeName">
				<!-- Name -->
				<xsl:call-template name="replace-string">
			     	<xsl:with-param name="text" select="name()"/>
			        <xsl:with-param name="from" select="'_'"/>
			        <xsl:with-param name="to" select="' '"/>
			    </xsl:call-template>
			</td>
			<td class="nodeValue">
				<!-- Value -->
				<xsl:apply-templates select="node()" />
			</td>
			</tr>
	    </xsl:for-each>
		</table>

    </xsl:for-each>

</xsl:template>




<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
                                FUNCTIONS
  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->


<!-- String replace function. -->
<xsl:template name="replace-string">
    <xsl:param name="text"/>
    <xsl:param name="from"/>
    <xsl:param name="to"/>

    <xsl:choose>
      <xsl:when test="contains($text, $from)">

	<xsl:variable name="before" select="substring-before($text, $from)"/>
	<xsl:variable name="after" select="substring-after($text, $from)"/>
	<xsl:variable name="prefix" select="concat($before, $to)"/>

	<xsl:value-of select="$before"/>
	<xsl:value-of select="$to"/>
        <xsl:call-template name="replace-string">
	  <xsl:with-param name="text" select="$after"/>
	  <xsl:with-param name="from" select="$from"/>
	  <xsl:with-param name="to" select="$to"/>
	</xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$text"/>
      </xsl:otherwise>
    </xsl:choose>
</xsl:template>


<!-- Value Handlers and Formatters -->
<xsl:template name="DoubleValueHandler">
	<xsl:param name="value" select="1" />
	<xsl:param name="base" select="1" />
	<xsl:param name="exp" select="1" />
	<xsl:param name="unit" select="1" />
	<xsl:choose>
		<xsl:when test="$base = 10 and $exp = 0 and $unit = 'b'">
			<xsl:value-of select="format-number($value, '0')" />&#160;<xsl:value-of select="$unit" />
		</xsl:when>
		<xsl:when test="$base = 10 and $unit = 'px'">
			<xsl:call-template name="power">
				<xsl:with-param name="base" select="10" />
				<xsl:with-param name="exp" select="$exp" />
				<xsl:with-param name="factor" select="$value" />
			</xsl:call-template>&#160;<xsl:value-of select="$unit" />
		</xsl:when>
		<xsl:when test="$base = 10 and $exp = 0">
			<xsl:value-of select="format-number($value, '0.0')" />&#160;<xsl:value-of select="$unit" />
		</xsl:when>
		<xsl:when test="$base = 10 and $exp = 6 and $unit = 'Hz'">
			<xsl:value-of select="format-number($value, '0.0')" />&#160;MHz
		</xsl:when>
		<xsl:when test="$base = 10 and $exp = 9 and $unit = 'Hz'">
			<xsl:value-of select="format-number($value, '0.0')" />&#160;GHz
		</xsl:when>
		<xsl:when test="$base = 2 and $exp = 0 and $unit = 'B'">
			<xsl:value-of select="format-number($value, '0')" />&#160;B
		</xsl:when>
		<xsl:when test="$base = 2 and $exp = 10 and $unit = 'B'">
			<xsl:value-of select="format-number($value, '0')" />&#160;KB
		</xsl:when>
		<xsl:when test="$base = 2 and $exp = 20 and $unit = 'B'">
			<xsl:value-of select="format-number($value, '0')" />&#160;MB
		</xsl:when>
		<xsl:when test="$base = 2 and $exp = 30 and $unit = 'B'">
			<xsl:value-of select="format-number($value, '0.00')" />&#160;GB
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="$value" />
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template match="DoubleValue">
	<xsl:choose>
		<xsl:when test="@base = 16 and @unit = 'B'">
			<xsl:call-template name="DoubleValueHandler">
				<xsl:with-param name="value">
					<xsl:call-template name="power">
						<xsl:with-param name="base" select="2" />
						<xsl:with-param name="exp" select="(@exp * 4) mod 10" />
						<xsl:with-param name="factor" select="." />
					</xsl:call-template>
				</xsl:with-param>
				<xsl:with-param name="base" select="2" />
				<xsl:with-param name="exp" select="(@exp * 4) - ( (@exp * 4) mod 10 )" />
				<xsl:with-param name="unit" select="@unit" />
			</xsl:call-template>
		</xsl:when>
		<xsl:otherwise>
			<xsl:call-template name="DoubleValueHandler">
				<xsl:with-param name="value" select="." />
				<xsl:with-param name="base" select="@base" />
				<xsl:with-param name="exp" select="@exp" />
				<xsl:with-param name="unit" select="@unit" />
			</xsl:call-template>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template match="IntValue">
	<xsl:choose>
		<xsl:when test="@base = 10 and @exp = 0">
			<xsl:value-of select="format-number(., '0')" />&#160;<xsl:value-of select="@unit" />
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="." />
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template match="EnumValue">
	<xsl:choose>
		<xsl:when test="String != ''">
			<xsl:apply-templates select="String" />
		</xsl:when>
		<xsl:otherwise>
			-
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>


<!-- Template for calculating power -->
<xsl:template name="power">
	<xsl:param name="base" select="1" />
	<xsl:param name="exp" select="1" />
	<xsl:param name="factor" select="1" />
	<xsl:param name="result" select="$base" />

	<xsl:choose>
		<xsl:when test="$exp > 1">
			<xsl:call-template name="power">
				<xsl:with-param name="base" select="$base" />
				<xsl:with-param name="exp" select="$exp - 1" />
				<xsl:with-param name="factor" select="$factor" />
				<xsl:with-param name="result" select="$result * $base" />
			</xsl:call-template>
		</xsl:when>
		<xsl:when test="$exp = 1">
			<xsl:value-of select="$result * $factor"/>
		</xsl:when>

		<xsl:when test="$exp &lt; -1">
			<xsl:call-template name="power">
				<xsl:with-param name="base" select="$base" />
				<xsl:with-param name="exp" select="$exp + 1" />
				<xsl:with-param name="factor" select="$factor" />
				<xsl:with-param name="result" select="$result * $base" />
			</xsl:call-template>
		</xsl:when>
		<xsl:when test="$exp = -1">
			<xsl:value-of select="( 1 div $result ) * $factor"/>
		</xsl:when>

		<xsl:when test="$exp = 0">
			<xsl:value-of select="$factor"/>
		</xsl:when>
	</xsl:choose>
</xsl:template>




</xsl:stylesheet>



